package FileManagement.DataSetTools.CSVTools;

import au.com.bytecode.opencsv.CSVReader;
import au.com.bytecode.opencsv.CSVWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Matty
 */
public class CSVTools {
    /**
     * 
     * @param filename
     * @param inDelimiter
     * @return 
     */
    public static ArrayList<ArrayList<String>> getCSVAsArray(String filename, char inDelimiter) {
        FileReader fileReader = null;
        ArrayList<ArrayList<String>> allElements = new ArrayList<>();
        List<String[]> temp;
        try {

            fileReader = new FileReader(filename);
            CSVReader reader = new CSVReader(fileReader, inDelimiter);
            temp = reader.readAll();
            for (int i = 0; i < temp.size(); i++) {
                ArrayList<String> tempArray = new ArrayList<>();
                tempArray.clear();
                tempArray.addAll(Arrays.asList(temp.get(i)));
                allElements.add(tempArray);
            }

        } catch (Exception ex) {
            Logger.getLogger(CSVTools.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                fileReader.close();
            } catch (IOException ex) {
                Logger.getLogger(CSVTools.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        return allElements;
    }

    /**
     * 
     * @param inArray
     * @return 
     */
    public static ArrayList<ArrayList<String>> getSquareArray(ArrayList<ArrayList<String>> inArray) {
        ArrayList<ArrayList<String>> temp = new ArrayList<>();
        int maxWidth = 0;
        for (int i = 0; i < inArray.size(); i++) {
            if (inArray.get(i).size() > maxWidth) {
                maxWidth = inArray.get(i).size();
            }
        }
        for (int i = 0; i < inArray.size(); i++) {
            temp.add(inArray.get(i));
            if (inArray.get(i).size() < maxWidth) {
                int shortSize = maxWidth - inArray.get(i).size();
                for (int j = 0; j < (shortSize); j++) {
                    temp.get(i).add(" ");
                }
            }
        }
        return temp;
    }

    /**
     * 
     * @param inArray
     * @return 
     */
    public static ArrayList<ArrayList<String>> removeSquareArray(ArrayList<ArrayList<String>> inArray) {
        for (int i = 0; i < inArray.size(); i++) {
            while (inArray.get(i).contains(" ")) {
                inArray.get(i).remove(" ");
            }
        }
        return inArray;
    }

    /**
     * 
     * @param fileName
     * @param delimiter
     * @param inArray 
     */
    public static void saveArrayToCSV(String fileName, char delimiter, ArrayList<ArrayList<String>> inArray) {
        FileWriter fileWriter = null;
        List<String[]> temp = new ArrayList<>();
        for (ArrayList<String> tempInArray : inArray) {
            String[] tempOutArray = tempInArray.toArray(new String[tempInArray.size()]);
            temp.add(tempOutArray);            
        }
        try {
            fileWriter = new FileWriter(fileName);
            CSVWriter writer = new CSVWriter(fileWriter, delimiter);
            writer.writeAll(temp);
        } catch (IOException ex) {
            Logger.getLogger(CSVTools.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
            try {
                fileWriter.close();
            } catch (IOException ex) {
                Logger.getLogger(CSVTools.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

}
