/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package FileManagement.FileTools;

import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.commons.io.FilenameUtils;

/**
 *
 * @author Matty
 */
public class AlgorithmFileType {

    private Integer algorithmNumber;
    private String algorithmName;
    private String description;
    private String inputFileType;
    private Integer numberOfParameters;
    private ArrayList<ArrayList<String>> parameterTypeAndDescription;
    public static final String RELATIONAL = "Relational";
    public static final String TRANSACTIONAL = "Transactional";
    
    /**
     * 
     * @param inAlgorithmNumber
     * @param inAlgorithmName
     * @param inDescription
     * @param inInputFileType
     * @param inNumberOfParameters
     * @param inParameterTypeAndDescription 
     */
    protected AlgorithmFileType(Integer inAlgorithmNumber,
            String inAlgorithmName,
            String inDescription,
            final String inInputFileType,
            Integer inNumberOfParameters,
            ArrayList<ArrayList<String>> inParameterTypeAndDescription) {
        algorithmNumber = inAlgorithmNumber;
        algorithmName = inAlgorithmName;
        description = inDescription;
        inputFileType = inInputFileType;
        numberOfParameters = inNumberOfParameters;
        parameterTypeAndDescription = inParameterTypeAndDescription;
    }

    /**
     * 
     * @param inAlgorithmName
     * @param inDescription
     * @param inInputFileType
     * @param inNumberOfParameters
     * @param inParameterTypeAndDescription 
     */
    public AlgorithmFileType(
            String inAlgorithmName,
            String inDescription,
            final String inInputFileType,
            Integer inNumberOfParameters,
            ArrayList<ArrayList<String>> inParameterTypeAndDescription) {
        algorithmNumber = setFileNumber();
        algorithmName = inAlgorithmName;
        description = inDescription;
        inputFileType = inInputFileType;
        numberOfParameters = inNumberOfParameters;
        parameterTypeAndDescription = inParameterTypeAndDescription;
    }

    /**
     * 
     * @return 
     */
    private Integer setFileNumber() {
        Integer temp = null;
        try {
            temp = FileCounter.getNextAlgorithmNumber();
        } catch (IOException ex) {
            Logger.getLogger(AlgorithmFileType.class.getName()).log(Level.SEVERE, null, ex);
        }
        return temp;
    }

    /**
     * 
     * @return 
     */
    public String getDescription() {
        return description;
    }

    /**
     * 
     * @return 
     */
    public String getInputFileType() {
        return inputFileType;
    }

    /**
     * 
     * @return 
     */
    public String getAlgorithmName() {
        return algorithmName;
    }

    /**
     * 
     * @return 
     */
    public Integer getNumberOfParameters() {
        return numberOfParameters;
    }

    /**
     * 
     * @return 
     */
    public Integer getAlgorithmNumber() {
        return algorithmNumber;
    }

    /**
     * 
     * @return 
     */
    public ArrayList<ArrayList<String>> getParameterTypeAndDescription() {
        return parameterTypeAndDescription;
    }

    /**
     * 
     * @return 
     */
    public String getFilePath() {
        String string = FileLocations.getAlgorithmFileLocation() + FilenameUtils.removeExtension(algorithmName) + "/" + algorithmName;
        return string;
    }

    /**
     * 
     * @return 
     */
    public String getFolderLocation() {
        String string = FileLocations.getAlgorithmFileLocation() + FilenameUtils.removeExtension(algorithmName);
        return string;
    }
}
