package FileManagement.FileTools;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Matty
 */
public class AnalysisFileType {

    private Integer fileNumber;
    private String fileName;
    private Integer originalFileNumber;

    /**
     * 
     * @param inFileName
     * @param inOriginalFileNumber 
     */
    public AnalysisFileType(String inFileName,
            Integer inOriginalFileNumber) {
        fileNumber = setFileNumber();
        fileName = inFileName;
        originalFileNumber = inOriginalFileNumber;
    }

    /**
     * 
     * @param inFileNumber
     * @param inFileName
     * @param inOriginalFileNumber 
     */
    protected AnalysisFileType(Integer inFileNumber, String inFileName,
            Integer inOriginalFileNumber) {
        fileNumber = inFileNumber;
        fileName = inFileName;
        originalFileNumber = inOriginalFileNumber;
    }

    /**
     * 
     * @return 
     */
    private Integer setFileNumber() {
        Integer temp = -1;
        try {
            temp = FileCounter.getNextAnalysisFileNumber();
        } catch (IOException ex) {
            Logger.getLogger(AnalysisFileType.class.getName()).log(Level.SEVERE, null, ex);
        }
        return temp;
    }

    /**
     * 
     * @return 
     */
    public Integer getFileNum() {
        return fileNumber;
    }

    /**
     * 
     * @return 
     */
    public String getFileName() {
        return fileName;
    }

    /**
     * 
     * @return 
     */
    public Integer getOriginalFileNum() {
        return originalFileNumber;
    }

    /**
     * 
     * @return 
     */
    public String getFilePath() {
        return FileLocations.getAnalysisFileLocation() + this.getFileName();
    }
}
