package FileManagement.FileTools;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import org.apache.commons.io.FileUtils;
import org.codehaus.jackson.map.ObjectMapper;
import org.codehaus.jackson.type.TypeReference;
import org.json.simple.JSONValue;

/**
 *
 * @author Matty
 */
public class FileCounter {

    public static final String fileName = FileLocations.getAppDataFileLocation() + "FileCounter.txt";

    /**
     * 
     * @return
     * @throws IOException 
     */
    protected static Integer getNextFileNumber() throws IOException {
        ArrayList<Integer> tempArray = read();
        Integer temp = tempArray.get(0);
        tempArray.set(0, temp + 1);
        saveFile(tempArray);
        return temp;
    }

    /**
     * 
     * @return
     * @throws IOException 
     */
    protected static Integer getNextAnalysisFileNumber() throws IOException {
        ArrayList<Integer> tempArray = read();
        Integer temp = tempArray.get(1);
        tempArray.set(1, temp + 1);
        saveFile(tempArray);
        return temp;
    }

    /**
     * 
     * @return
     * @throws IOException 
     */
    protected static Integer getNextAlgorithmNumber() throws IOException {
        ArrayList<Integer> tempArray = read();
        Integer temp = tempArray.get(2);
        tempArray.set(2, temp + 1);
        saveFile(tempArray);
        return temp;
    }

    /**
     * 
     * @param inArray
     * @throws IOException 
     */
    private static void saveFile(ArrayList<Integer> inArray) throws IOException {
        String serialized = JSONValue.toJSONString(inArray);
        FileUtils.writeStringToFile(new File(fileName), serialized);
    }

    /**
     * 
     * @return
     * @throws IOException 
     */
    private static ArrayList<Integer> read() throws IOException {
        ObjectMapper mapper = new ObjectMapper();
        ArrayList<Integer> temp = mapper.readValue(
                new File(fileName),
                new TypeReference<ArrayList<Integer>>() {
                });
        return temp;
    }

    /**
     * 
     * @throws IOException 
     */
    protected static void setFileCounter() throws IOException {
        ArrayList<Integer> tempArray = new ArrayList<>();
        tempArray.add(0);
        tempArray.add(0);
        tempArray.add(0);
        saveFile(tempArray);
    }

    /**
     * 
     * @return
     * @throws IOException 
     */
    public static Integer getCurrentAlgorithmNumber() throws IOException {
        ArrayList<Integer> tempArray = read();
        Integer temp = tempArray.get(2);
        return temp;
    }

    /**
     * 
     * @return
     * @throws IOException 
     */
    public static Integer getCurrentFileNumber() throws IOException {
        ArrayList<Integer> tempArray = read();
        Integer temp = tempArray.get(0);
        return temp;
    }
}
