package FileManagement.FileTools;

import java.io.File;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import org.xml.sax.SAXException;

/**
 *
 * @author Matty
 */
public class FileLocations {

    private static DocumentBuilder builder;
    private static DocumentBuilderFactory fact;
    private static File file;
    private static Document document;
    private static String datasetFileLocation, resultFileLocation, algorithmLocation, analysisLocation;

    private FileLocations() {
        try {
            String path = FileLocations.class.getProtectionDomain().getCodeSource().getLocation().getPath();
            path = URLDecoder.decode(path, "UTF-8");
            file = new File(new File(path).getParentFile().getPath() + File.separator + "Resources" + File.separator + "FileLocations.xml");
            fact = DocumentBuilderFactory.newInstance();
            builder = fact.newDocumentBuilder();
            document = builder.parse(file);
            NodeList nodes_i = document.getDocumentElement().getChildNodes();
            for (int i = 0; i < nodes_i.getLength(); i++) {
                Node node_i = nodes_i.item(i);
                if (node_i.getNodeType() == Node.ELEMENT_NODE && ((Element) node_i).getTagName().equals("FileLocation")) {
                    Element fileLocation = (Element) node_i;
                    NodeList nodes_j = fileLocation.getChildNodes();
                    for (int j = 0; j < nodes_j.getLength(); j++) {
                        Node node_j = nodes_j.item(j);
                        if (node_j.getNodeType() == Node.ELEMENT_NODE) {
                            Element outstring = (Element) node_j;
                            if (outstring.getTagName().equals("DatasetFiles")) {
                                datasetFileLocation = outstring.getTextContent();
                            }
                            if (outstring.getTagName().equals("ResultFiles")) {
                                resultFileLocation = outstring.getTextContent();
                            }
                            if (outstring.getTagName().equals("AlgorithmFiles")) {
                                algorithmLocation = outstring.getTextContent();
                            }
                            if (outstring.getTagName().equals("AnalysisFiles")) {
                                analysisLocation = outstring.getTextContent();
                            }
                        }
                    }
                }
            }
        } catch (ParserConfigurationException | SAXException | IOException | DOMException ex) {
            Logger.getLogger(FileLocations.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
        }
    }

    /**
     * 
     * @return 
     */
    public static String getDatasetFileLocation() {
        FileLocations test = new FileLocations();
        return datasetFileLocation;
    }

    /**
     * 
     * @return 
     */
    public static String getResultFileLocation() {
        FileLocations test = new FileLocations();
        return resultFileLocation;
    }

    /**
     * 
     * @return 
     */
    public static String getAppDataFileLocation() {
        String path = FileLocations.class.getProtectionDomain().getCodeSource().getLocation().getPath();
        File tempFile = new File(new File(path).getParentFile().getPath() + File.separator + "Resources/");
        return tempFile.getPath() + "/";
    }

    /**
     * 
     * @return 
     */
    public static String getAlgorithmFileLocation() {
        FileLocations test = new FileLocations();
        return algorithmLocation;
    }

    /**
     * 
     * @return 
     */
    public static String getAnalysisFileLocation() {
        FileLocations test = new FileLocations();
        return analysisLocation;
    }

    private static void setFiles() {
    }
}
