package FileManagement.FileTools;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import FileManagement.FileTools.FileCounter;

/**
 *
 * @author Matty
 */
public class FileTypes {

    private Integer fileNumber;
    private String fileName;
    private char delimiter;
    private Integer analysisFileNumber;
    private String description;
    public static final String RELATIONAL = "Relational";
    public static final String TRANSACTIONAL = "Transactional";

    /**
     * 
     * @param inFileNumber
     * @param inFileName
     * @param inDelimiter 
     */
    protected FileTypes(Integer inFileNumber, String inFileName, char inDelimiter, String inDescription, Integer inAnalysisFileNumber) {
        fileNumber = inFileNumber;
        fileName = inFileName;
        delimiter = inDelimiter;
        analysisFileNumber = inAnalysisFileNumber;
        description = inDescription;
    }

    /**
     * 
     * @param inFileName
     * @param inDelimiter 
     */
    protected FileTypes(String inFileName, char inDelimiter, String inDescription, Integer inAnalysisFileNumber) {
        fileName = inFileName;
        fileNumber = setFileNumber();
        delimiter = inDelimiter;
        description = inDescription;
        analysisFileNumber = inAnalysisFileNumber;
    }

    /**
     * 
     * @return 
     */
    public Integer getFileNum() {
        return fileNumber;
    }

    /**
     * 
     * @return 
     */
    public String getFileName() {
        return fileName;
    }

    /**
     * 
     * @return 
     */
    public char getDelimiter() {
        return delimiter;
    }

    /**
     * 
     * @return 
     */
    private Integer setFileNumber() {
        Integer temp = null;
        try {
            temp = FileCounter.getNextFileNumber();
        } catch (IOException ex) {
            Logger.getLogger(FileTypes.class.getName()).log(Level.SEVERE, null, ex);
        }
        return temp;
    }

    /**
     * 
     * @return 
     */
    public String getDescription() {
        return description;
    }

    /**
     * 
     * @param inString 
     */
    public void setDescription(String inString) {
        description = inString;
    }

    /**
     * 
     * @return 
     */
    public Integer getAnalysisFileNumber() {
        return analysisFileNumber;
    }

    /**
     * 
     * @param inFileNumber 
     */
    public void setAnalysisFileNumber(int inFileNumber) {
        analysisFileNumber = inFileNumber;
    }
}
