package FileManagement.FileTools;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URL;
import java.util.ArrayList;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.apache.commons.io.FileUtils;
import org.w3c.dom.*;
import org.xml.sax.SAXException;

/**
 *
 * @author Matty
 */
public class ResultFileManager {

    private static DocumentBuilder builder;
    private static DocumentBuilderFactory fact;
    private static URL url;
    private static URI uri;
    private static File file;
    private static Document document;
    private static Integer fileNumber;
    private static String fileName;
    private static String description;
    private static char delimiter;
    private static Integer datasetFileNumber;
    private static Integer analysisFileNumber;
    private static ArrayList<ResultFileType> fileList;
    public static Lock lock = new ReentrantLock();

    /**
     * 
     * @param inList 
     */
    private static void setDomInstance(String inList) {
        file = new File(FileLocations.getAppDataFileLocation() + inList);
        fact = DocumentBuilderFactory.newInstance();
        try {
            builder = fact.newDocumentBuilder();
        } catch (Exception ex) {
            Logger.getLogger(DatasetFileManager.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * 
     */
    private static void resultFileList() {
        do {
            if (lock.tryLock()) {
                try {
                    setDomInstance("ResultList.xml");
                    fileList = new ArrayList<>();
                    if (file.isFile()) {
                        document = builder.parse(file);
                        NodeList nodes_i = document.getDocumentElement().getChildNodes();
                        for (int i = 0; i < nodes_i.getLength(); i++) {
                            Node node_i = nodes_i.item(i);
                            if (node_i.getNodeType() == Node.ELEMENT_NODE && ((Element) node_i).getTagName().equals("ResultFile")) {
                                Element fileLocation = (Element) node_i;
                                NodeList nodes_j = fileLocation.getChildNodes();
                                for (int j = 0; j < nodes_j.getLength(); j++) {
                                    Node node_j = nodes_j.item(j);
                                    if (node_j.getNodeType() == Node.ELEMENT_NODE) {
                                        Element outstring = (Element) node_j;
                                        fileNumber = Integer.parseInt(outstring.getAttribute("ID"));
                                        NodeList nodes_k = outstring.getChildNodes();
                                        for (int k = 0; k < nodes_k.getLength(); k++) {
                                            Node node_k = nodes_k.item(k);
                                            if (node_k.getNodeType() == Node.ELEMENT_NODE) {
                                                Element nextstring = (Element) node_k;
                                                if (nextstring.getTagName().equals("AnalysisFileNumber")) {
                                                    analysisFileNumber = Integer.parseInt(nextstring.getAttribute("Num"));
                                                }
                                                if (nextstring.getTagName().equals("ResultName")) {
                                                    fileName = nextstring.getTextContent();
                                                }
                                                if (nextstring.getTagName().equals("OriginalDatasetFileNumber")) {
                                                    datasetFileNumber = Integer.parseInt(nextstring.getAttribute("Num"));
                                                }
                                                if (nextstring.getTagName().equals("Description")) {
                                                    description = nextstring.getTextContent();
                                                }
                                                if (nextstring.getTagName().equals("Delimiter")) {
                                                    delimiter = nextstring.getTextContent().charAt(0);
                                                }
                                            }
                                        }
                                        ResultFileType temp = new ResultFileType(fileNumber, fileName, delimiter, description, datasetFileNumber, analysisFileNumber);
                                        fileList.add(temp);
                                    }
                                }
                            }
                        }
                    }
                } catch (SAXException | IOException | NumberFormatException | DOMException ex) {
                    Logger.getLogger(DatasetFileManager.class.getName()).log(Level.SEVERE, null, ex);
                } finally {
                    lock.unlock();
                    break;
                }

            }
        } while (true);
    }

    /**
     * 
     * @param inFileList 
     */
    public static void saveFileList(ArrayList<ResultFileType> inFileList) {
        lock.lock();
        setDomInstance("ResultList.xml");
        document = builder.newDocument();
        Element rootElement = document.createElement("ResultList");
        document.appendChild(rootElement);
        for (int i = 0; i < inFileList.size(); i++) {
            Element em1 = document.createElement("ResultFile");
            rootElement.appendChild(em1);

            Element em2 = document.createElement("ResultSetID");
            em2.setAttribute("ID", inFileList.get(i).getFileNum().toString());
            em1.appendChild(em2);

            Element em3 = document.createElement("ResultName");
            em3.appendChild(document.createTextNode(inFileList.get(i).getFileName()));
            em2.appendChild(em3);

            Element delimiterElement = document.createElement("Delimiter");
            delimiterElement.appendChild(document.createTextNode(Character.toString(inFileList.get(i).getDelimiter())));
            em2.appendChild(delimiterElement);

            Element em4 = document.createElement("Description");
            em4.appendChild(document.createTextNode(inFileList.get(i).getDescription()));
            em2.appendChild(em4);

            Element em5 = document.createElement("OriginalDatasetFileNumber");
            em5.setAttribute("Num", inFileList.get(i).getOriginalDatasetNumber().toString());
            em2.appendChild(em5);

            Element em6 = document.createElement("AnalysisFileNumber");
            em6.setAttribute("Num", inFileList.get(i).getAnalysisFileNumber().toString());
            em2.appendChild(em6);
        }
        TransformerFactory transformerFactory = TransformerFactory.newInstance();
        Transformer transformer;
        try {
            transformer = transformerFactory.newTransformer();
            DOMSource source = new DOMSource(document);
            StreamResult result = new StreamResult(file);
            transformer.setOutputProperty(OutputKeys.ENCODING, "ISO-8859-1");
            transformer.setOutputProperty(OutputKeys.INDENT, "yes");
            transformer.transform(source, result);
        } catch (TransformerException ex) {
            Logger.getLogger(DatasetFileManager.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            lock.unlock();
        }
    }

    /**
     * 
     * @return 
     */
    public static ArrayList<ResultFileType> getResultFileList() {
        try {
            resultFileList();
        } catch (Exception ex) {
            Logger.getLogger(DatasetFileManager.class.getName()).log(Level.SEVERE, null, ex);
        }
        return fileList;
    }

    /**
     * 
     * @param inFileNumber
     * @return 
     */
    public static String getFileName(Integer inFileNumber) {
        ArrayList<ResultFileType> temp = getResultFileList();
        for (ResultFileType tempFile : temp) {
            if (tempFile.getFileNum() == inFileNumber) {
                return tempFile.getFileName();
            }
        }
        return "not found";
    }

    /**
     * 
     * @param inFileName
     * @return 
     */
    public static ResultFileType getFile(String inFileName) {
        ArrayList<ResultFileType> temp = getResultFileList();
        for (ResultFileType tempFile : temp) {
            if (tempFile.getFileName().equals(inFileName)) {
                return tempFile;
            }
        }
        return null;
    }

    /**
     * 
     * @param inFileNumber
     * @return 
     */
    public static ResultFileType getFile(Integer inFileNumber) {
        ArrayList<ResultFileType> temp = getResultFileList();
        for (ResultFileType tempFile : temp) {
            if (tempFile.getFileNum() == inFileNumber) {
                return tempFile;
            }
        }
        return null;
    }

    /**
     * 
     * @param inType 
     */
    public static void updateFile(ResultFileType inType) {
        ArrayList<ResultFileType> temp = getResultFileList();
        for (int i = 0; i < temp.size(); i++) {
            if (temp.get(i).getFileNum() == inType.getFileNum()) {
                temp.set(i, inType);
                saveFileList(temp);
            }
        }
    }

    /**
     * 
     * @param inFile
     * @param outFile 
     */
    public static void addFileToList(File inFile, ResultFileType outFile) {
        try {
            resultFileList();
            fileList.add(outFile);
            moveFile(inFile, FileLocations.getResultFileLocation() + outFile.getFileName());
            saveFileList(fileList);
        } catch (Exception ex) {
            Logger.getLogger(DatasetFileManager.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * 
     * @param outFile 
     */
    public static void addFileInfoToList(ResultFileType outFile) {
        try {
            resultFileList();
            fileList.add(outFile);
            saveFileList(fileList);
        } catch (Exception ex) {
            Logger.getLogger(DatasetFileManager.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * 
     * @param srcFile
     * @param dstFile 
     */
    private static void moveFile(File srcFile, String dstFile) {
        try {
            File outFile = new File(dstFile);
            FileUtils.copyFile(srcFile, outFile);
        } catch (IOException ex) {
            Logger.getLogger(DatasetFileManager.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * 
     * @param inFileNumber 
     */
    public static void removeFileFromList(Integer inFileNumber) {
        ArrayList<ResultFileType> temp = getResultFileList();
        for (int i = 0; i < temp.size(); i++) {
            if (temp.get(i).getFileNum() == inFileNumber) {
                try {
                    File deleteFile = new File(FileLocations.getResultFileLocation() + temp.get(i).getFileName());
                    FileUtils.forceDelete(deleteFile);
                    if (temp.get(i).getAnalysisFileNumber() != -1) {
                        AnalysisFileManager.removeFileFromList(temp.get(i).getAnalysisFileNumber());
                    }
                    temp.remove(i);
                    saveFileList(temp);
                    break;
                } catch (IOException ex) {
                    Logger.getLogger(DatasetFileManager.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }

    /**
     * 
     * @param inFileNumber
     * @return 
     */
    public static String getDatasetAbsoluteFileLocation(Integer inFileNumber) {
        String temp = FileLocations.getResultFileLocation() + getFileName(inFileNumber);
        return temp;
    }

    /**
     * 
     * @param inFileNumber
     * @return 
     */
    public static String[] getFilesFromOriginalDatasetAsArray(Integer inFileNumber) {
        ArrayList<ResultFileType> temp = getResultFileList();
        String[] tempArray = new String[temp.size() + 1];
        tempArray[0] = "";
        for (int i = 0; i < temp.size(); i++) {
            if (temp.get(i).getOriginalDatasetNumber() == inFileNumber) {
                String string = temp.get(i).getFileName();
                tempArray[i + 1] = string;
            }
        }
        return tempArray;
    }
}
