package FileManagement.FileTools;

import java.io.IOException;

/**
 *
 * @author Matty
 */
public class ResultFileType extends FileTypes {
    
    private Integer originalDatasetFileNumber;   

    /**
     * 
     * @param inOriginalDatasetFileNumber
     * @param inFileName
     * @param inDelimiter
     * @param inDescription
     * @throws IOException 
     */
    public ResultFileType(Integer inOriginalDatasetFileNumber, String inFileName, char inDelimiter, String inDescription) throws IOException {
        super(inFileName, inDelimiter,inDescription,-1);
        originalDatasetFileNumber = inOriginalDatasetFileNumber;
    }

    /**
     * 
     * @param inFileNumber
     * @param inFileName
     * @param inDelimiter
     * @param inDescription
     * @param inOriginalDatasetFileNumber
     * @param inAnalysisFileNumber 
     */
    protected ResultFileType(Integer inFileNumber,
            String inFileName,
            char inDelimiter,
            String inDescription,
            Integer inOriginalDatasetFileNumber,
            Integer inAnalysisFileNumber) {
        super(inFileNumber, inFileName, inDelimiter,inDescription,inAnalysisFileNumber);
        originalDatasetFileNumber = inOriginalDatasetFileNumber;
    }

    /**
     * 
     * @return 
     */
    public Integer getOriginalDatasetNumber() {
        return originalDatasetFileNumber;
    }

    /**
     * 
     * @return 
     */
    public String getOriginalFileType() {
        return DatasetFileManager.getFile(originalDatasetFileNumber).getFileType();
    }

    /**
     * 
     * @return 
     */
    public String getFilePath() {
        return FileLocations.getResultFileLocation() + this.getFileName();
    }


}
