package GUI.TestToolGUI.FileChooser;

import javax.swing.JFileChooser;

/**
 * 
 *
 * @author Matthew Connop
 */
public class GUIFileChooser extends JFileChooser {

    public static final int DIRECTORIESFILTER = 0;
    public static final int DATASETFILTER = 1;
    public static final int ALGORITHMFILTER = 2;

    /**
     * 
     */
    public GUIFileChooser() {
        super();
    }

    /**
     * 
     * @param fileSelectionMode 
     */
    public void setSelectionFilter(final int fileSelectionMode) {
        if (fileSelectionMode == 0) {
            this.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        }
        if (fileSelectionMode == 1) {
            this.addChoosableFileFilter(new DatasetFilter());
            this.setFileSelectionMode(JFileChooser.FILES_ONLY);
        }
        if (fileSelectionMode == 2) {
            this.addChoosableFileFilter(new AlgorithmFilter());
            this.setFileSelectionMode(JFileChooser.FILES_ONLY);
        }
        this.setAcceptAllFileFilterUsed(false);
    }

    /**
     * 
     * @return 
     */
    public JFileChooser getFileChooserInstance() {
        return this;
    }
}
