package GUI.TestToolGUI;

import GUI.TestToolGUI.ToolBar.ToolHolder;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.net.URL;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;

/**
 *
 * @author Matthew Connop
 */
public class MainWindow extends JFrame implements Runnable {

    private JLabel mainLabel;
    private URL myurl = this.getClass().getResource("/Images/MainIcon.png"); //
    private URL myurlSmall = this.getClass().getResource("/Images/MainIconSmall.png");
    private Toolkit tk = this.getToolkit();
    private Image img = tk.getImage(myurl);
    private Image imgSmall = tk.getImage(myurlSmall);
    private ImageIcon image = new ImageIcon(img);

    /**
     * 
     */
    public void MainWindow() {
    }

    /**
     * 
     */
    private void addToolBar() {
        ToolHolder toolHolder = new ToolHolder(this);
        add(toolHolder, BorderLayout.EAST);
    }

    /**
     * 
     */
    private void createAndShowGUI() {
        setSize(420, 350);
        setTitle("Privacy Protection Algorithm Test Tool");
        setLayout(new BorderLayout());
        mainLabel = new JLabel(image);
        mainLabel.setBorder(BorderFactory.createLineBorder(Color.black));
        this.setIconImage(imgSmall);
        add(mainLabel, BorderLayout.CENTER);
        //addMenuBar();
        addToolBar();
        this.setVisible(true);
        addWindowListener(new WindowAdapter() {

            @Override
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }

    /**
     * 
     */
    @Override
    public void run() {
        createAndShowGUI();
    }

    /**
     * 
     * @param args
     * @throws InterruptedException 
     */
    public static void main(String[] args) throws InterruptedException {
        SwingUtilities.invokeLater(new MainWindow());
    }
}
