package GUI.TestToolGUI.ManageFilePanes;

import FileManagement.FileTools.DatasetFileManager;
import FileManagement.FileTools.DatasetFileType;
import GUI.TestToolGUI.InformationBar.InformationBar;
import java.awt.Color;
import java.util.ArrayList;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 *
 * @author Matty
 */
public class DatasetListPane extends JScrollPane implements ListSelectionListener {

    private JList contentList;
    private String value;
    private ArrayList<DatasetFileType> fileList;
    protected InformationBar infoBar;
    protected JFrame parentPane;

    /**
     * 
     * @param inInfoBar 
     */
    public DatasetListPane(InformationBar inInfoBar, JFrame inParentPane) {
        setBackground(Color.RED);
        fileList = DatasetFileManager.getDatasetFileList();
        infoBar = inInfoBar;
        contentList = new JList(getList(fileList).toArray());
        contentList.addListSelectionListener((ListSelectionListener) this);
        contentList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        parentPane = inParentPane;
        this.getViewport().add(contentList, null); // Must add JList
        this.validate();
    }

    /**
     * 
     * @param inFileList
     * @return 
     */
    private ArrayList<String> getList(ArrayList<DatasetFileType> inFileList) {
        ArrayList<String> temp = new ArrayList<>();
        for (int i = 0; i < inFileList.size(); i++) {
            String tempFileName = "Dataset ID: " + inFileList.get(i).getFileNum().toString() + "   File Name: " + inFileList.get(i).getFileName();
            temp.add(tempFileName);
        }
        return temp;
    }

    /**
     * 
     * @param e 
     */
    @Override
    public void valueChanged(ListSelectionEvent e) {
        if (e.getSource() == contentList && !e.getValueIsAdjusting()) {
            value = (String) contentList.getSelectedValue();
            if (value != null) {
                int temp = contentList.getSelectedIndex();
                String[] string = new String[3];
                string[0] = "File Number: " + fileList.get(temp).getFileNum().toString();
                string[1] = "File Name: " + fileList.get(temp).getFileName().toString();
                string[2] = "Description: " + fileList.get(temp).getDescription().toString();
                infoBar.addInfo(string);
                parentPane.validate();
            }
        }
    }

    /**
     * 
     */
    public void updateList() {
        fileList = DatasetFileManager.getDatasetFileList();
        contentList.setListData(getList(fileList).toArray());
        this.revalidate();
        this.repaint();
    }

    /**
     * 
     * @return 
     */
    public Integer getFileNumber() {
        return fileList.get(contentList.getSelectedIndex()).getFileNum();
    }
}
