package GUI.TestToolGUI.ManageFilePanes;

import GUI.TestToolGUI.InformationBar.InformationBar;
import GUI.TestToolGUI.ManageFilePanes.Buttons.AddAlgorithmButton;
import GUI.TestToolGUI.ManageFilePanes.Buttons.CancelButton;
import GUI.TestToolGUI.ManageFilePanes.Buttons.RemoveAlgorithmButton;
import GUI.TestToolGUI.ManageFilePanes.Buttons.RunAlgorithmButton;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.FileNotFoundException;
import java.net.URISyntaxException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 *
 * @author Matty
 */
public class ManageAlgorithmPane extends JFrame implements Runnable {

    private AlgorithmListPane panel;
    protected InformationBar infoPanel;
    private JFrame mainWindow;

    /**
     * 
     * @param inMainWindow 
     */
    public ManageAlgorithmPane(JFrame inMainWindow) {
        super();
        mainWindow = inMainWindow;
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                mainWindow.setVisible(true);
            }
        });
    }

    /**
     * 
     * @throws FileNotFoundException
     * @throws URISyntaxException 
     */
    private void addAlgorithmList() throws FileNotFoundException, URISyntaxException {
        infoPanel = new InformationBar(this.getWidth(), 50);
        panel = new AlgorithmListPane(infoPanel,this);
        this.add(panel, BorderLayout.CENTER);
        this.add(infoPanel, BorderLayout.SOUTH);
    }

    /**
     * 
     */
    private void addButtons() {
        JPanel buttonHolder = new JPanel();
        buttonHolder.setLayout(new GridLayout(1, 4));
        AddAlgorithmButton addButton = new AddAlgorithmButton(this);
        buttonHolder.add(addButton);
        RemoveAlgorithmButton removeButton = new RemoveAlgorithmButton(this);
        buttonHolder.add(removeButton);
        RunAlgorithmButton runButton = new RunAlgorithmButton(this);
        buttonHolder.add(runButton);
        CancelButton cancelButton = new CancelButton(this, mainWindow);
        buttonHolder.add(cancelButton);
        add(buttonHolder, BorderLayout.NORTH);
    }

    /**
     * 
     * @throws FileNotFoundException
     * @throws URISyntaxException 
     */
    private void createAndShow() throws FileNotFoundException, URISyntaxException {
        setTitle("Algorithm Manager");
        this.setSize(400, 300);
        setLayout(new BorderLayout());
        addAlgorithmList();
        addButtons();
    }

    /**
     * 
     */
    public void updateList() {
        panel.updateList();
        infoPanel.clearLabel();
    }

    /**
     * 
     * @return 
     */
    public Integer getFileSelection() {
        return panel.getFileNumber();
    }

    /**
     * 
     */
    @Override
    public void run() {
        try {
            try {
                createAndShow();
            } catch (URISyntaxException ex) {
                Logger.getLogger(ManageDatasetPane.class.getName()).log(Level.SEVERE, null, ex);
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(ManageDatasetPane.class.getName()).log(Level.SEVERE, null, ex);
        }
        this.setVisible(true);
    }
}
