package GUI.TestToolGUI.ManageFilePanes;

import GUI.TestToolGUI.InformationBar.InformationBar;
import GUI.TestToolGUI.ManageFilePanes.Buttons.AddResultButton;
import GUI.TestToolGUI.ManageFilePanes.Buttons.CancelButton;
import GUI.TestToolGUI.ManageFilePanes.Buttons.RemoveResultButton;
import GUI.TestToolGUI.ManageFilePanes.Buttons.ViewResultButton;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.FileNotFoundException;
import java.net.URISyntaxException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 *
 * @author Matty
 */
public class ManageResultPane extends JFrame implements Runnable {

    private ResultListPane panel;
    protected InformationBar infoPanel;
    private JFrame mainWindow;

    /**
     * 
     * @param inMainWindow 
     */
    public ManageResultPane(JFrame inMainWindow) {
        mainWindow = inMainWindow;
        addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                mainWindow.setVisible(true);
            }
        });
    }

    /**
     * 
     * @throws FileNotFoundException
     * @throws URISyntaxException 
     */
    private void addAlgorithmList() throws FileNotFoundException, URISyntaxException {
        infoPanel = new InformationBar(this.getWidth(), 50);
        panel = new ResultListPane(infoPanel,this);
        this.add(panel, BorderLayout.CENTER);
        this.add(infoPanel, BorderLayout.SOUTH);
    }

    /**
     * 
     */
    private void addButtons() {
        JPanel buttonHolder = new JPanel();
        buttonHolder.setLayout(new GridLayout(1, 4));
        ViewResultButton viewButton = new ViewResultButton(this);
        buttonHolder.add(viewButton);
        AddResultButton addButton = new AddResultButton(this);
        buttonHolder.add(addButton);
        RemoveResultButton removeButton = new RemoveResultButton(this);
        buttonHolder.add(removeButton);
        CancelButton cancelButton = new CancelButton(this, mainWindow);
        buttonHolder.add(cancelButton);
        add(buttonHolder, BorderLayout.NORTH);
    }

    /**
     * 
     * @throws FileNotFoundException
     * @throws URISyntaxException 
     */
    private void createAndShow() throws FileNotFoundException, URISyntaxException {
        setTitle("Result Manager");
        this.setSize(400, 300);
        setLayout(new BorderLayout());
        addAlgorithmList();
        addButtons();
    }

    /**
     * 
     */
    public void updateList() {
        panel.updateList();
        infoPanel.clearLabel();
    }

    /**
     * 
     * @return 
     */
    public Integer getFileSelection() {
        return panel.getFileNumber();
    }

    /**
     * 
     */
    @Override
    public void run() {
        try {
            createAndShow();
            this.setVisible(true);
        } catch (FileNotFoundException | URISyntaxException ex) {
            Logger.getLogger(ManageResultPane.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
