/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GUI.TestToolGUI.ManageFilePanes;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import net.java.dev.designgridlayout.DesignGridLayout;

/**
 *
 * @author Matty
 */
public class NewAlgorithmPaneParameterPane extends JFrame implements ActionListener, Runnable {
    //

    private JLabel[] parameterTypeLabel;
    private JLabel[] parameterDescriptionLabel;
    private ArrayList<ArrayList<String>> parameterTypeAndDescription;
    private JTextField[] parameterType;
    private JTextField[] parameterDescription;
    private JScrollPane parameterEntryPanelScrollPane;
    private JPanel parameterEntryPanel;
    private JButton okButton;
    private Integer numberOfParameters;
    private DesignGridLayout parameterEntryLayout;
    private NewAlgorithmPane parentPane;

    /**
     * 
     * @param inNumberOfParameters
     * @param inParentPane 
     */
    public NewAlgorithmPaneParameterPane(Integer inNumberOfParameters, NewAlgorithmPane inParentPane) {
        super();
        numberOfParameters = inNumberOfParameters;
        parentPane = inParentPane;
    }

    /**
     * 
     */
    private void createAndShow() {
        parameterEntryPanel = new JPanel();
        parameterEntryPanel.setSize(this.getWidth(), 200);
        okButton = new JButton("DONE");
        okButton.addActionListener(this);
        setParameterTypeAndDescriptionEntryPanel(numberOfParameters, parameterEntryPanel);
        parameterEntryPanelScrollPane = new JScrollPane(parameterEntryPanel);
        parameterEntryLayout.row().grid().add(okButton);
        this.add(parameterEntryPanelScrollPane);
    }

    /**
     * 
     * @param noOfParameters
     * @param inPanel 
     */
    private void setParameterTypeAndDescriptionEntryPanel(Integer noOfParameters, JPanel inPanel) {
        parameterEntryLayout = new DesignGridLayout(inPanel);
        parameterTypeLabel = new JLabel[noOfParameters];
        parameterDescriptionLabel = new JLabel[noOfParameters];
        parameterType = new JTextField[noOfParameters];
        parameterDescription = new JTextField[noOfParameters];
        for (int i = 0; i < noOfParameters; i++) {
            parameterTypeLabel[i] = new JLabel("Param " + (i + 1));
            parameterDescriptionLabel[i] = new JLabel("Description " + (i + 1));
            if (i == 0) {
                parameterType[i] = new JTextField(20);
                parameterType[i].setText("String");
                parameterType[i].setEditable(false);
                parameterDescription[i] = new JTextField(20);
                parameterDescription[i].setText("Input File");
                parameterDescription[i].setEditable(false);
            }
            if (i == 1) {
                parameterType[i] = new JTextField(20);
                parameterType[i].setText("String");
                parameterType[i].setEditable(false);
                parameterDescription[i] = new JTextField(20);
                parameterDescription[i].setText("Output File");
                parameterDescription[i].setEditable(false);
            }
            if (i >= 2) {
                parameterType[i] = new JTextField(20);
                parameterDescription[i] = new JTextField(20);
            }
            parameterEntryLayout.row().grid().add(parameterTypeLabel[i]).add(parameterType[i]).add(parameterDescriptionLabel[i]).add(parameterDescription[i]);
        }
        inPanel.repaint();
        inPanel.revalidate();
    }

    /**
     * 
     * @param ae 
     */
    @Override
    public void actionPerformed(ActionEvent ae) {
        parameterTypeAndDescription = new ArrayList<>();
        parameterTypeAndDescription.clear();
        for (int i = 0; i < numberOfParameters; i++) {
            ArrayList<String> temp = new ArrayList<>();
            String paramType = parameterType[i].getText();
            String paramDesc = parameterDescription[i].getText();
            temp.add(paramType);
            temp.add(paramDesc);
            parameterTypeAndDescription.add(temp);
        }
        parentPane.setParameterList(parameterTypeAndDescription);
        this.setVisible(false);
        this.dispose();
    }

    /**
     * 
     */
    @Override
    public void run() {
        createAndShow();
        this.pack();
        this.setVisible(true);
    }
}
