package MeasurementTools.Measures;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author Matty
 */
public class UtilityMeasure {

    /**
     * 
     */
    public static final String MEASURETYPE = "Relational";
    /**
     * 
     */
    public static final String MEASURENAME = "Utility Measure";
 
    /**
     * 
     * @param inDataset
     * @param QIDs
     * @return 
     */
    private static ArrayList<ArrayList<String>> getQIDsAsArrayList(ArrayList<ArrayList<String>> inDataset, int[] QIDs) {
        ArrayList<ArrayList<String>> temp = new ArrayList<>();
        for (int i = 0; i < inDataset.size(); i++) {
            ArrayList<String> temp2 = new ArrayList<>();
            for (int j = 0; j < QIDs.length; j++) {
                String tempString = inDataset.get(i).get(QIDs[j]);
                temp2.add(tempString);
            }
            temp.add(temp2);
        }
        return temp;
    }

    /**
     * 
     * @param inDataset
     * @param QIDs
     * @return 
     */
    private static HashMap<ArrayList<String>, Integer> getQIDCount(ArrayList<ArrayList<String>> inDataset, int[] QIDs) {
        HashMap<ArrayList<String>, Integer> wordCount = new HashMap<>();
        ArrayList<ArrayList<String>> dataset = getQIDsAsArrayList(inDataset, QIDs);
        for (ArrayList<String> row : dataset) {
            Integer count = wordCount.get(row);
            wordCount.put(row, (count == null) ? 1 : count + 1);
        }
        return wordCount;
    }

    /**
     * 
     * @param dataset
     * @param QIDs
     * @return 
     */
    public static float returnUtilityMeasure(ArrayList<ArrayList<String>> dataset, int[] QIDs) {
        float temp = 0;
        HashMap<ArrayList<String>, Integer> tempMap = getQIDCount(dataset, QIDs);
        for (ArrayList<String> key : tempMap.keySet()) {
            temp += tempMap.get(key)*tempMap.get(key);
        }
        return temp;
    }
}
